#pragma config(Sensor, S1,     SGyro,          sensorEV3_Gyro, modeEV3Gyro_RateAndAngle)
#pragma config(Sensor, S2,     SLeft,          sensorEV3_Color)
#pragma config(Sensor, S3,     SRight,         sensorEV3_Color)
#pragma config(Sensor, S4,     SColor,         sensorEV3_Color, modeEV3Color_Color)
#pragma config(Motor,  motorA,          MLine,         tmotorEV3_Large, PIDControl, encoder)
#pragma config(Motor,  motorB,          MLeft,         tmotorEV3_Large, PIDControl, encoder)
#pragma config(Motor,  motorC,          MRight,        tmotorEV3_Large, PIDControl, encoder)
#pragma config(Motor,  motorD,          MClash,        tmotorEV3_Large, PIDControl, encoder)
//*!!Code automatically generated by 'ROBOTC' configuration wizard               !!*//



#define WheelD 56
#define BaseD  161	// izmerit' on a new robot
#define WhiteSLeft 50
#define BlackSLeft 50
#define WhiteSRight 50
#define BlackSRight 50
#define ELine nMotorEncoder[MLine]
#define ELeft nMotorEncoder[MLeft]
#define ERight nMotorEncoder[MRight]
#define EClash nMotorEncoder[MClash]


int MidPointSLeft = (WhiteSLeft + BlackSLeft) / 2;
int MidPointSRight = (WhiteSRight + BlackSRight) / 2;

int lasterror = 0;
int error = 0;
int integral = 0;
int derivative = 0;

void pmove(float KProportional, float K1, int P){
	 error = (MidPointSLeft - SensorValue[SLeft]) - (MidPointSRight - SensorValue[SRight]);
	 integral = error + integral;
	 derivative = error - lasterror;
	 int correction = KProportional * error + K1 * error *error * error;
	 motor[MLeft] = P - correction;
	 motor[MRight] = P + correction;
	 lasterror = error;
}

void turn(int angle) {
	int A = BaseD * angle / WheelD;
	ELeft = 0;
	while (abs(A) > abs(ELeft)) {
		int power = (A - ELeft) / A * 50 + 20;
		if (abs(power) < 5) power = power / abs(power) * 5;
		motor[motorB] = power;
		motor[motorC] = -power;
	}
	motor[motorB] = motor[motorC] = 0;
}

void moveForward(int length) {
	int L = length * 360 / PI / WheelD;
	ELeft = 0;
	while (L > ELeft) {
		int power = (L - ELeft) / L * 50 + 20;
		if (abs(power) < 5) power = power / abs(power) * 5;
		motor[motorB] = power;
		motor[motorC] = power;
	}
	motor[motorB] = motor[motorC] = 0;
}

void pmoveForward(int KProportional, float K1, int P, int length) {
	int L = length * 360 / PI / WheelD;
	ERight = 0;
	ELeft = 0;
	while (L > ELeft && L > ERight) {
		pmove( KProportional, K1, P);

	}
	motor[motorB] = motor[motorC] = 0;
}


task main(){
	pmoveForward(1, 0.01, 60, 4200);
	pmoveForward(3, 0.01, 50, 700);

	pmoveForward(1,0.1, 80, 900);
	pmoveForward(2, 0.01 ,50, 2200);

}
